<template>
    <div style="height: 100vh;" class="container">
        <div class="content-block">
            <h3 v-if="!error">Идет авторизация ...</h3>
            <div class="white-block warning-block" v-if="error">
                <strong>Ошибка</strong>
                <br>
                <b>Не все параметры заданы</b>
            </div>
        </div>
    </div>
</template>

<script>
	export default {
		name: 'adminlogin',
		data() {
			return {
				error: false,
			};
		},
		created() {
			const token = this.$route.query.token;
			const tokenExpired = this.$route.query.exp || Math.round(this.$dayjs().add(12, 'h').getTime() / 1000);

			if(!token) {
				this.$toastr.error('Токен не задан');
				this.$methods.user.logout();
				return false;
            }

			this.AJAX_LOADING({
                caption: 'Ожидайте...',
                waitingTitle: 'Загрузка данных',
                isShow: true,
                name: 'rootFixed'
			});
			const data = {token, tokenExpired};
			this.$methods.user.setToken(data);

			this.$methods.user.getUserData().then(async () => {
				console.log('%cSuccess auth', 'color: green');
			}).then(() => {
				console.log('%cGet loans data', 'color: gray');
				return new Promise((resolve, reject) => {
					this.$methods.loan.getLoans().then(() => {
						console.log('%cLoans data loaded', 'color: green');
						this.$methods.user.redirect();
						this.$toastr.success(`Вы вошли как ${this.$user.userInicial}`);
						return resolve();
					}).catch((code) => {
						console.error('%cLoans data load fail, code: ', code);

						return reject(code);
					});
				});
			}).catch(() => {
				this.$toastr.error('Токен не действителен', 'Ошибка');
				this.$methods.user.logout();
			}).finally(() => {
				console.log('%cAll done', 'color: green;font-weight: bold');
				this.AJAX_LOADING(false);

			});
		},
	};
</script>

<style scoped>
    .content-block {
        margin-left: auto;
    }
</style>
